//============================================================================
// Name        : aconvert.cpp
// Author      : Martin Zak
// Version     :
// Copyright   : 
// Description :
//============================================================================

#include <iostream>

#include "grammar/UnknownGrammar.h"
#include "GrammarFactory.h"
#include "AlibException.h"

using namespace std;
using namespace grammar;
using namespace alib;

#include "GrammarDiff.h"

int main(int argc, char** argv) {

	UnknownGrammar grammar1;
	UnknownGrammar grammar2;

	try {

		if (argc == 2 && string("-h").compare(argv[1]) == 0) {
			cout << "Grammar diff.\nUsage: adiff grammar1.xml grammar2.xml\n";
			return -1;
		}

		if (argc == 3) {
			grammar1 = GrammarFactory::fromFile(argv[1]);
			grammar2 = GrammarFactory::fromFile(argv[2]);
		}

		GrammarDiff::diff(grammar1, grammar2);
	} catch (AlibException& e) {
		cout << e.getCause() << endl;
		return 0;
	}
}
