/*
 * EpsilonRemover.h
 *
 *  Created on: 16. 1. 2014
 *      Author: tomas
 */

#ifndef EPSILONREMOVER_H_
#define EPSILONREMOVER_H_

#include <map>
#include <algorithm>

#include <automaton/FSM/FSM.h>
#include <AlibException.h>

#include "EpsilonClosure.h"

namespace epsilon
{

class EpsilonRemover
{
public:
    EpsilonRemover( const automaton::FSM & fsm );
    ~EpsilonRemover( void );
    const automaton::FSM remove( void );

private:
    void setTransitions( void );
    void setFinalStates( void );

    const automaton::FSM & m_origFSM;
    automaton::FSM m_fsm;

    EpsilonClosure * m_closure;
    std::map<automaton::State, std::set<automaton::TransitionFSM>> m_transitionsBySourceState;

};

} /* namespace epsilon */

#endif /* EPSILONREMOVER_H_ */
