/*
 * TrimNFA.h
 *
 *  Created on: 18. 1. 2014
 *      Author: tomas
 */

#ifndef TRIMNFA_H_
#define TRIMNFA_H_

#include <automaton/FSM/FSM.h>
#include <AlibException.h>

#include <algorithm>
#include <iterator>
#include <map>
#include <set>

namespace trim
{

#define isInSet(x,set) ( (set).find((x)) != (set).end())

/**
 * Well, this is just simple BFS/DFS, but we implement Melichar, 2.29 algorithm.
 */
class TrimNFA
{
public:
    TrimNFA( const automaton::FSM & fsm );
    const automaton::FSM remove( void );

private:
    const std::set<automaton::State> findReachableStates( void ) const;

    const automaton::FSM & m_origFSM;
    automaton::FSM m_FSM;
};

} /* namespace trim */

#endif /* TRIMNFA_H_ */
